"""
KorysProjects
"""

__authors__ = 'Jaroslav Šatkevič <jaro@akl.lt>'
__docformat__ = 'restructuredtext'

from AccessControl import ModuleSecurityInfo
from AccessControl import allow_module, allow_class, allow_type

from Globals import package_home

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore import utils as cmf_utils
from Products.CMFCore.FSPageTemplate import FSPageTemplate
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.DirectoryView import registerFileExtension
from Products.Archetypes import public as atapi

import config
#from permissions import initialize as initialize_permissions

#import monkey
#import Extensions.setup

# Register Global Tools/Services/Config
# (Skins)
registerFileExtension('xsl', FSPageTemplate)
registerDirectory(config.SKINS_DIR, config.GLOBALS)

# Importing the content types allows for their registration
# with the Archetypes runtime
#from content import *

def initialize(context):
    # Register customization policy
    import policy
    policy.register(context, config.GLOBALS)

    from AccessControl import ModuleSecurityInfo

    #ModuleSecurityInfo('Products.Intranet.interfaces').declarePublic('IWriteWorkflowPolicySupport')

    # Ask Archetypes to handback all the type information needed
    # to make the CMF happy.
    types = atapi.listTypes(config.PROJECTNAME)
    content_types, constructors, ftis = atapi.process_types( types,
                                                             config.PROJECTNAME)
    #permissions = initialize_permissions()
    allTypes = zip(content_types, constructors)
    for atype, constructor in allTypes:
        kind = "%s: %s" % (config.PROJECTNAME, atype.archetype_name)
        cmf_utils.ContentInit(
            kind,
            content_types      = (atype,),
            permission         = permissions[atype.portal_type],
            extra_constructors = (constructor,),
            fti                = ftis,
            ).initialize(context)
        